import { EditorBase } from "../../../EditorBase";
import { EditorType } from "object-gui";
export class BackgroundOptionsEditor extends EditorBase {
    constructor(particles) {
        super(particles);
    }
    addToGroup(parent) {
        this.group = parent.addGroup("background", "Background");
        this.options = this.group.data;
        this.addColor();
        this.addProperties();
    }
    addColor() {
        const options = this.options().color;
        this.group
            .addProperty("color", "Color", EditorType.color, options.value, false)
            .change(async (value) => {
            const options = this.options().color;
            if (typeof value === "string") {
                options.value = value;
            }
            this.notifyEditorChanged();
        });
    }
    addProperties() {
        this.group.addProperty("image", "Image", EditorType.string).change(async () => {
            await this.particles().refresh();
        });
        this.group
            .addProperty("opacity", "Opacity", EditorType.number)
            .change(async () => {
            await this.particles().refresh();
        })
            .step(0.01)
            .min(0)
            .max(1);
        this.group.addProperty("position", "Position", EditorType.string).change(async () => {
            await this.particles().refresh();
        });
        this.group.addProperty("repeat", "Repeat", EditorType.string).change(async () => {
            await this.particles().refresh();
        });
        this.group.addProperty("size", "Size", EditorType.string).change(async () => {
            await this.particles().refresh();
        });
    }
}
