import { EditorBase } from "../../../EditorBase";
import { EditorType } from "object-gui";
import { EventsOptionsEditor } from "./Events/EventsOptionsEditor";
import { ModesOptionsEditor } from "./Modes/ModesOptionsEditor";
export class InteractivityOptionsEditor extends EditorBase {
    constructor(particles) {
        super(particles);
    }
    addToGroup(parent) {
        this.group = parent.addGroup("interactivity", "Interactivity");
        this.options = this.group.data;
        this.addEvents();
        this.addModes();
        this.addProperties();
    }
    addEvents() {
        const options = new EventsOptionsEditor(this.particles);
        options.addToGroup(this.group);
    }
    addModes() {
        const options = new ModesOptionsEditor(this.particles);
        options.addToGroup(this.group);
    }
    addProperties() {
        this.group
            .addProperty("detectsOn", "Detects On", EditorType.select)
            .change(async () => {
            await this.particles().refresh();
        })
            .addItems([
            {
                value: "canvas",
            },
            {
                value: "parent",
            },
            {
                value: "window",
            },
        ]);
    }
}
