import { EditorBase } from "../../../../EditorBase";
import { EditorType } from "object-gui";
export class ColorOptionsEditor extends EditorBase {
    constructor(particles) {
        super(particles);
    }
    addToGroup(parent, options) {
        this.group = parent.addGroup("color", "Color", true, options);
        this.options = this.group.data;
        this.addAnimation();
        this.addProperties();
    }
    addAnimation() {
        const group = this.group.addGroup("animation", "Animation");
        group.addProperty("enable", "Enable", EditorType.boolean).change(async () => {
            await this.particles().refresh();
        });
        group.addProperty("speed", "Speed", EditorType.number).change(async () => {
            await this.particles().refresh();
        });
        group.addProperty("sync", "Sync", EditorType.boolean).change(async () => {
            await this.particles().refresh();
        });
    }
    addProperties() {
        this.group.addProperty("value", "Value", EditorType.color).change(async () => {
            await this.particles().refresh();
        });
    }
}
