import { EditorBase } from "../../../../EditorBase";
import { EditorType } from "object-gui";
export class NumberOptionsEditor extends EditorBase {
    constructor(particles) {
        super(particles);
    }
    addToGroup(parent) {
        this.group = parent.addGroup("number", "Number");
        this.options = this.group.data;
        this.addDensity();
        this.addProperties();
    }
    addDensity() {
        const group = this.group.addGroup("density", "Density");
        group.addProperty("area", "Area", EditorType.number).change(async () => {
            await this.particles().refresh();
        });
        group.addProperty("enable", "Enable", EditorType.boolean).change(async () => {
            await this.particles().refresh();
        });
        group.addProperty("factor", "Factor", EditorType.number).change(async () => {
            await this.particles().refresh();
        });
    }
    addProperties() {
        this.group.addProperty("limit", "Limit", EditorType.number).change(async () => {
            await this.particles().refresh();
        });
        this.group.addProperty("max", "Max", EditorType.number).change(async () => {
            await this.particles().refresh();
        });
        this.group.addProperty("value", "Value", EditorType.number).change(async () => {
            await this.particles().refresh();
        });
    }
}
