import { EditorBase } from "../../../../EditorBase";
import { EditorType } from "object-gui";
export class RotateOptionsEditor extends EditorBase {
    constructor(particles) {
        super(particles);
    }
    addToGroup(parent) {
        this.group = parent.addGroup("rotate", "Rotate");
        this.options = this.group.data;
        this.addAnimation();
        this.addProperties();
    }
    addAnimation() {
        const group = this.group.addGroup("animation", "Animation");
        group.addProperty("enable", "Enable", EditorType.boolean).change(async () => {
            await this.particles().refresh();
        });
        group.addProperty("speed", "Speed", EditorType.number).change(async () => {
            await this.particles().refresh();
        });
        group.addProperty("sync", "Sync", EditorType.boolean).change(async () => {
            await this.particles().refresh();
        });
    }
    addProperties() {
        this.group
            .addProperty("direction", "Direction", EditorType.select)
            .change(async () => {
            await this.particles().refresh();
        })
            .addItems([
            {
                value: "clockwise",
            },
            {
                value: "counter-clockwise",
            },
            {
                value: "random",
            },
        ]);
        this.group.addProperty("path", "Path", EditorType.boolean).change(async () => {
            await this.particles().refresh();
        });
        this.group.addProperty("random", "Random", EditorType.boolean).change(async () => {
            await this.particles().refresh();
        });
        this.group.addProperty("value", "Value", EditorType.number).change(async () => {
            await this.particles().refresh();
        });
    }
}
