import { EditorBase } from "../../../../EditorBase";
import { EditorType } from "object-gui";
export class SizeOptionsEditor extends EditorBase {
    constructor(particles) {
        super(particles);
    }
    addToGroup(parent) {
        this.group = parent.addGroup("size", "Size");
        this.options = this.group.data;
        this.addAnimation();
        this.addRandom();
        this.addProperties();
    }
    addAnimation() {
        const group = this.group.addGroup("animation", "Animation");
        group
            .addProperty("destroy", "Destroy", EditorType.select)
            .change(async () => {
            await this.particles().refresh();
        })
            .addItems([
            {
                value: "max",
            },
            {
                value: "min",
            },
            {
                value: "none",
            },
        ]);
        group.addProperty("enable", "Enable", EditorType.boolean).change(async () => {
            await this.particles().refresh();
        });
        group.addProperty("minimumValue", "Minimum Value", EditorType.number).change(async () => {
            await this.particles().refresh();
        });
        group.addProperty("speed", "Speed", EditorType.number).change(async () => {
            await this.particles().refresh();
        });
        group
            .addProperty("startValue", "Start Value", EditorType.select)
            .change(async () => {
            await this.particles().refresh();
        })
            .addItems([
            {
                value: "max",
            },
            {
                value: "min",
            },
            {
                value: "random",
            },
        ]);
        group.addProperty("sync", "Sync", EditorType.boolean).change(async () => {
            await this.particles().refresh();
        });
    }
    addProperties() {
        this.group.addProperty("value", "Value", EditorType.number).change(async () => {
            await this.particles().refresh();
        });
    }
    addRandom() {
        const group = this.group.addGroup("random", "Random");
        group.addProperty("enable", "Enable", EditorType.boolean).change(async () => {
            await this.particles().refresh();
        });
        group.addProperty("minimumValue", "Minimum Value", EditorType.number).change(async () => {
            await this.particles().refresh();
        });
    }
}
