import { EditorBase } from "../../../../EditorBase";
import { EditorType } from "object-gui";
export class WobbleOptionsEditor extends EditorBase {
    constructor(particles) {
        super(particles);
    }
    addToGroup(parent) {
        this.group = parent.addGroup("wobble", "Wobble");
        this.options = this.group.data;
        this.addProperties();
    }
    addProperties() {
        this.group.addProperty("distance", "Distance", EditorType.number).change(async () => {
            await this.particles().refresh();
        });
        this.group.addProperty("enable", "Enable", EditorType.boolean).change(async () => {
            await this.particles().refresh();
        });
        this.group.addProperty("speed", "Speed", EditorType.number).change(async () => {
            await this.particles().refresh();
        });
    }
}
