"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FullScreenOptionsEditor = void 0;
const EditorBase_1 = require("../../../EditorBase");
const object_gui_1 = require("object-gui");
class FullScreenOptionsEditor extends EditorBase_1.EditorBase {
    constructor(particles) {
        super(particles);
    }
    addToGroup(parent) {
        this.group = parent.addGroup("fullScreen", "Full Screen");
        this.options = this.group.data;
        this.addProperties();
    }
    addProperties() {
        this.group.addProperty("enable", "Enable", object_gui_1.EditorType.boolean).change(async () => {
            await this.particles().refresh();
        });
        this.group.addProperty("zIndex", "zIndex", object_gui_1.EditorType.number).change(async () => {
            await this.particles().refresh();
        });
    }
}
exports.FullScreenOptionsEditor = FullScreenOptionsEditor;
