"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InteractivityOptionsEditor = void 0;
const EditorBase_1 = require("../../../EditorBase");
const object_gui_1 = require("object-gui");
const EventsOptionsEditor_1 = require("./Events/EventsOptionsEditor");
const ModesOptionsEditor_1 = require("./Modes/ModesOptionsEditor");
class InteractivityOptionsEditor extends EditorBase_1.EditorBase {
    constructor(particles) {
        super(particles);
    }
    addToGroup(parent) {
        this.group = parent.addGroup("interactivity", "Interactivity");
        this.options = this.group.data;
        this.addEvents();
        this.addModes();
        this.addProperties();
    }
    addEvents() {
        const options = new EventsOptionsEditor_1.EventsOptionsEditor(this.particles);
        options.addToGroup(this.group);
    }
    addModes() {
        const options = new ModesOptionsEditor_1.ModesOptionsEditor(this.particles);
        options.addToGroup(this.group);
    }
    addProperties() {
        this.group
            .addProperty("detectsOn", "Detects On", object_gui_1.EditorType.select)
            .change(async () => {
            await this.particles().refresh();
        })
            .addItems([
            {
                value: "canvas",
            },
            {
                value: "parent",
            },
            {
                value: "window",
            },
        ]);
    }
}
exports.InteractivityOptionsEditor = InteractivityOptionsEditor;
