"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ColorOptionsEditor = void 0;
const EditorBase_1 = require("../../../../EditorBase");
const object_gui_1 = require("object-gui");
class ColorOptionsEditor extends EditorBase_1.EditorBase {
    constructor(particles) {
        super(particles);
    }
    addToGroup(parent, options) {
        this.group = parent.addGroup("color", "Color", true, options);
        this.options = this.group.data;
        this.addAnimation();
        this.addProperties();
    }
    addAnimation() {
        const group = this.group.addGroup("animation", "Animation");
        group.addProperty("enable", "Enable", object_gui_1.EditorType.boolean).change(async () => {
            await this.particles().refresh();
        });
        group.addProperty("speed", "Speed", object_gui_1.EditorType.number).change(async () => {
            await this.particles().refresh();
        });
        group.addProperty("sync", "Sync", object_gui_1.EditorType.boolean).change(async () => {
            await this.particles().refresh();
        });
    }
    addProperties() {
        this.group.addProperty("value", "Value", object_gui_1.EditorType.color).change(async () => {
            await this.particles().refresh();
        });
    }
}
exports.ColorOptionsEditor = ColorOptionsEditor;
