"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RotateOptionsEditor = void 0;
const EditorBase_1 = require("../../../../EditorBase");
const object_gui_1 = require("object-gui");
class RotateOptionsEditor extends EditorBase_1.EditorBase {
    constructor(particles) {
        super(particles);
    }
    addToGroup(parent) {
        this.group = parent.addGroup("rotate", "Rotate");
        this.options = this.group.data;
        this.addAnimation();
        this.addProperties();
    }
    addAnimation() {
        const group = this.group.addGroup("animation", "Animation");
        group.addProperty("enable", "Enable", object_gui_1.EditorType.boolean).change(async () => {
            await this.particles().refresh();
        });
        group.addProperty("speed", "Speed", object_gui_1.EditorType.number).change(async () => {
            await this.particles().refresh();
        });
        group.addProperty("sync", "Sync", object_gui_1.EditorType.boolean).change(async () => {
            await this.particles().refresh();
        });
    }
    addProperties() {
        this.group
            .addProperty("direction", "Direction", object_gui_1.EditorType.select)
            .change(async () => {
            await this.particles().refresh();
        })
            .addItems([
            {
                value: "clockwise",
            },
            {
                value: "counter-clockwise",
            },
            {
                value: "random",
            },
        ]);
        this.group.addProperty("path", "Path", object_gui_1.EditorType.boolean).change(async () => {
            await this.particles().refresh();
        });
        this.group.addProperty("random", "Random", object_gui_1.EditorType.boolean).change(async () => {
            await this.particles().refresh();
        });
        this.group.addProperty("value", "Value", object_gui_1.EditorType.number).change(async () => {
            await this.particles().refresh();
        });
    }
}
exports.RotateOptionsEditor = RotateOptionsEditor;
