"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SizeOptionsEditor = void 0;
const EditorBase_1 = require("../../../../EditorBase");
const object_gui_1 = require("object-gui");
class SizeOptionsEditor extends EditorBase_1.EditorBase {
    constructor(particles) {
        super(particles);
    }
    addToGroup(parent) {
        this.group = parent.addGroup("size", "Size");
        this.options = this.group.data;
        this.addAnimation();
        this.addRandom();
        this.addProperties();
    }
    addAnimation() {
        const group = this.group.addGroup("animation", "Animation");
        group
            .addProperty("destroy", "Destroy", object_gui_1.EditorType.select)
            .change(async () => {
            await this.particles().refresh();
        })
            .addItems([
            {
                value: "max",
            },
            {
                value: "min",
            },
            {
                value: "none",
            },
        ]);
        group.addProperty("enable", "Enable", object_gui_1.EditorType.boolean).change(async () => {
            await this.particles().refresh();
        });
        group.addProperty("minimumValue", "Minimum Value", object_gui_1.EditorType.number).change(async () => {
            await this.particles().refresh();
        });
        group.addProperty("speed", "Speed", object_gui_1.EditorType.number).change(async () => {
            await this.particles().refresh();
        });
        group
            .addProperty("startValue", "Start Value", object_gui_1.EditorType.select)
            .change(async () => {
            await this.particles().refresh();
        })
            .addItems([
            {
                value: "max",
            },
            {
                value: "min",
            },
            {
                value: "random",
            },
        ]);
        group.addProperty("sync", "Sync", object_gui_1.EditorType.boolean).change(async () => {
            await this.particles().refresh();
        });
    }
    addProperties() {
        this.group.addProperty("value", "Value", object_gui_1.EditorType.number).change(async () => {
            await this.particles().refresh();
        });
    }
    addRandom() {
        const group = this.group.addGroup("random", "Random");
        group.addProperty("enable", "Enable", object_gui_1.EditorType.boolean).change(async () => {
            await this.particles().refresh();
        });
        group.addProperty("minimumValue", "Minimum Value", object_gui_1.EditorType.number).change(async () => {
            await this.particles().refresh();
        });
    }
}
exports.SizeOptionsEditor = SizeOptionsEditor;
