import { ClickEventsOptionsEditor } from "./ClickEventsOptionsEditor";
import { DivsEventsOptionsEditor } from "./DivsEventsOptionsEditor";
import { EditorBase } from "../../../../EditorBase";
import { EditorType } from "object-gui";
import { HoverEventsOptionsEditor } from "./HoverEventsOptionsEditor";
export class EventsOptionsEditor extends EditorBase {
    constructor(particles) {
        super(particles);
    }
    addToGroup(parent) {
        this.group = parent.addGroup("events", "Events");
        this.options = this.group.data;
        this.addClick();
        this.addDivs();
        this.addHover();
        this.addProperties();
    }
    addClick() {
        const clickEditor = new ClickEventsOptionsEditor(this.particles);
        clickEditor.addToGroup(this.group);
    }
    addDivs() {
        const divsEditor = new DivsEventsOptionsEditor(this.particles);
        divsEditor.addToGroup(this.group);
    }
    addHover() {
        const hoverEditor = new HoverEventsOptionsEditor(this.particles);
        hoverEditor.addToGroup(this.group);
    }
    addProperties() {
        this.group.addProperty("resize", "Resize", EditorType.boolean).change(async () => {
            await this.particles().refresh();
        });
    }
}
