import { EditorBase } from "../../../../EditorBase";
import { EditorType } from "object-gui";
export class HoverEventsOptionsEditor extends EditorBase {
    constructor(particles) {
        super(particles);
    }
    addToGroup(parent) {
        this.group = parent.addGroup("onHover", "Hover Events");
        this.options = this.group.data;
        this.addParallax();
        this.addProperties();
    }
    addParallax() {
        const parallax = this.group.addGroup("parallax", "Parallax");
        parallax.addProperty("enable", "Enable", EditorType.boolean).change(async () => {
            await this.particles().refresh();
        });
        parallax.addProperty("force", "Force", EditorType.number).change(async () => {
            await this.particles().refresh();
        });
        parallax.addProperty("smooth", "Smooth", EditorType.number).change(async () => {
            await this.particles().refresh();
        });
    }
    addProperties() {
        this.group.addProperty("enable", "Enable", EditorType.boolean).change(async () => {
            await this.particles().refresh();
        });
        this.group
            .addProperty("mode", "Mode", EditorType.select)
            .change(async () => {
            await this.particles().refresh();
        })
            .addItems([
            {
                value: "attract",
            },
            {
                value: "bubble",
            },
            {
                value: "connect",
            },
            {
                value: "grab",
            },
            {
                value: "light",
            },
            {
                value: "repulse",
            },
            {
                value: "slow",
            },
            {
                value: "trail",
            },
        ]);
    }
}
