import { EditorBase } from "../../../EditorBase";
import { EditorType } from "object-gui";
export class MotionOptionsEditor extends EditorBase {
    constructor(particles) {
        super(particles);
    }
    addToGroup(parent) {
        this.group = parent.addGroup("motion", "Motion");
        this.options = this.group.data;
        this.addReduce();
        this.addProperties();
    }
    addProperties() {
        this.group.addProperty("disable", "Disable", EditorType.boolean).change(async () => {
            await this.particles().refresh();
        });
    }
    addReduce() {
        const coverGroup = this.group.addGroup("reduce", "Reduce");
        coverGroup
            .addProperty("factor", "Factor", EditorType.number)
            .change(async () => {
            await this.particles().refresh();
        })
            .step(1);
        coverGroup.addProperty("value", "Value", EditorType.boolean).change(async () => {
            await this.particles().refresh();
        });
    }
}
