import { EditorBase } from "../../../../EditorBase";
import { EditorType } from "object-gui";
export class BounceOptionsEditor extends EditorBase {
    constructor(particles) {
        super(particles);
    }
    addToGroup(parent) {
        this.group = parent.addGroup("bounce", "Bounce");
        this.options = this.group.data;
        this.addFactors();
    }
    addFactor(name, title) {
        const group = this.group.addGroup(name, title), randomGroup = group.addGroup("random", "Random");
        randomGroup.addProperty("enable", "Enable", EditorType.boolean).change(async () => {
            await this.particles().refresh();
        });
        randomGroup.addProperty("minimumValue", "Minimum Value", EditorType.number).change(async () => {
            await this.particles().refresh();
        });
        group.addProperty("value", "Value", EditorType.number).change(async () => {
            await this.particles().refresh();
        });
    }
    addFactors() {
        this.addFactor("horizontal", "Horizontal");
        this.addFactor("vertical", "Vertical");
    }
}
