import { EditorBase } from "../../../../EditorBase";
import { EditorType } from "object-gui";
export class CollisionsOptionsEditor extends EditorBase {
    constructor(particles) {
        super(particles);
    }
    addToGroup(parent) {
        this.group = parent.addGroup("collisions", "Collisions");
        this.options = this.group.data;
        this.addBounce();
        this.addOverlap();
        this.addProperties();
    }
    addBounce() {
        const group = this.group.addGroup("bounce", "Bounce");
        this.addBounceFactor(group, "horizontal", "Horizontal");
        this.addBounceFactor(group, "vertical", "Vertical");
    }
    addBounceFactor(parentGroup, name, title) {
        const group = parentGroup.addGroup(name, title);
        const randomGroup = group.addGroup("random", "Random");
        randomGroup.addProperty("enable", "Enable", EditorType.boolean).change(async () => {
            await this.particles().refresh();
        });
        randomGroup.addProperty("minimumValue", "Minimum Value", EditorType.number).change(async () => {
            await this.particles().refresh();
        });
        group.addProperty("value", "Value", EditorType.number).change(async () => {
            await this.particles().refresh();
        });
    }
    addOverlap() {
        const group = this.group.addGroup("overlap", "Overlap");
        group.addProperty("enable", "Enable", EditorType.boolean).change(async () => {
            await this.particles().refresh();
        });
        group.addProperty("retries", "Retries", EditorType.number).change(async () => {
            await this.particles().refresh();
        });
    }
    addProperties() {
        this.group.addProperty("enable", "Enable", EditorType.boolean).change(async () => {
            await this.particles().refresh();
        });
        this.group
            .addProperty("mode", "Mode", EditorType.select)
            .change(async () => {
            await this.particles().refresh();
        })
            .addItems([
            {
                value: "absorb",
            },
            {
                value: "bounce",
            },
            {
                value: "destroy",
            },
        ]);
    }
}
