import { EditorBase } from "../../../../EditorBase";
import { EditorType } from "object-gui";
export class OpacityOptionsEditor extends EditorBase {
    constructor(particles) {
        super(particles);
    }
    addToGroup(parent, options) {
        this.group = parent.addGroup("opacity", "Opacity", true, options);
        this.options = this.group.data;
        this.addAnimation();
        this.addRandom();
        this.addProperties();
    }
    addAnimation() {
        const group = this.group.addGroup("animation", "Animation");
        group
            .addProperty("destroy", "Destroy", EditorType.select)
            .change(async () => {
            await this.particles().refresh();
        })
            .addItems([
            {
                value: "max",
            },
            {
                value: "min",
            },
            {
                value: "none",
            },
        ]);
        group.addProperty("enable", "Enable", EditorType.boolean).change(async () => {
            await this.particles().refresh();
        });
        group
            .addProperty("minimumValue", "Minimum Value", EditorType.number)
            .change(async () => {
            await this.particles().refresh();
        })
            .min(0)
            .max(0)
            .step(0.01);
        group
            .addProperty("speed", "Speed", EditorType.number)
            .change(async () => {
            await this.particles().refresh();
        })
            .step(0.01);
        group
            .addProperty("startValue", "Start Value", EditorType.select)
            .change(async () => {
            await this.particles().refresh();
        })
            .addItems([
            {
                value: "max",
            },
            {
                value: "min",
            },
            {
                value: "random",
            },
        ]);
        group.addProperty("sync", "Sync", EditorType.boolean).change(async () => {
            await this.particles().refresh();
        });
    }
    addProperties() {
        this.group
            .addProperty("value", "Value", EditorType.number)
            .change(async () => {
            await this.particles().refresh();
        })
            .min(0)
            .max(1)
            .step(0.01);
    }
    addRandom() {
        const group = this.group.addGroup("random", "Random");
        group.addProperty("enable", "Enable", EditorType.boolean).change(async () => {
            await this.particles().refresh();
        });
        group.addProperty("minimumValue", "Minimum Value", EditorType.number).change(async () => {
            await this.particles().refresh();
        });
    }
}
