import { EditorBase } from "../../../../EditorBase";
import { EditorType } from "object-gui";
export class ShadowOptionsEditor extends EditorBase {
    constructor(particles) {
        super(particles);
    }
    addToGroup(parent) {
        this.group = parent.addGroup("shadow", "Shadow");
        this.options = this.group.data;
        this.addOffset();
        this.addProperties();
    }
    addOffset() {
        const group = this.group.addGroup("offset", "Offset");
        group.addProperty("x", "X", EditorType.number).change(async () => {
            await this.particles().refresh();
        });
        group.addProperty("y", "Y", EditorType.number).change(async () => {
            await this.particles().refresh();
        });
    }
    addProperties() {
        const optionsFunc = () => this.options();
        const options = optionsFunc();
        const color = typeof options.color === "string" ? options.color : options.color?.value;
        this.group.addProperty("blur", "Blur", EditorType.number).change(async () => {
            await this.particles().refresh();
        });
        this.group.addProperty("color", "Color", EditorType.color, color, false).change(async (value) => {
            if (typeof value === "string") {
                if (typeof options.color === "string") {
                    options.color = value;
                }
                else {
                    options.color.value = value;
                }
            }
            await this.particles().refresh();
        });
        this.group.addProperty("enable", "Enable", EditorType.boolean).change(async () => {
            await this.particles().refresh();
        });
    }
}
