(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "tsparticles-engine", "./Utils"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.EditorBase = void 0;
    const tsparticles_engine_1 = require("tsparticles-engine");
    const Utils_1 = require("./Utils");
    class EditorBase {
        constructor(particles) {
            this.particles = particles;
        }
        notifyEditorChanged() {
            tsparticles_engine_1.tsParticles.dispatchEvent(Utils_1.editorChangedEvent, {
                container: this.particles(),
            });
        }
    }
    exports.EditorBase = EditorBase;
});
