(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../../../EditorBase", "object-gui"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.FullScreenOptionsEditor = void 0;
    const EditorBase_1 = require("../../../EditorBase");
    const object_gui_1 = require("object-gui");
    class FullScreenOptionsEditor extends EditorBase_1.EditorBase {
        constructor(particles) {
            super(particles);
        }
        addToGroup(parent) {
            this.group = parent.addGroup("fullScreen", "Full Screen");
            this.options = this.group.data;
            this.addProperties();
        }
        addProperties() {
            this.group.addProperty("enable", "Enable", object_gui_1.EditorType.boolean).change(async () => {
                await this.particles().refresh();
            });
            this.group.addProperty("zIndex", "zIndex", object_gui_1.EditorType.number).change(async () => {
                await this.particles().refresh();
            });
        }
    }
    exports.FullScreenOptionsEditor = FullScreenOptionsEditor;
});
