(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../../../../EditorBase", "object-gui", "tsparticles-plugin-absorbers", "tsparticles-plugin-emitters"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.ClickEventsOptionsEditor = void 0;
    const EditorBase_1 = require("../../../../EditorBase");
    const object_gui_1 = require("object-gui");
    const tsparticles_plugin_absorbers_1 = require("tsparticles-plugin-absorbers");
    const tsparticles_plugin_emitters_1 = require("tsparticles-plugin-emitters");
    class ClickEventsOptionsEditor extends EditorBase_1.EditorBase {
        constructor(particles) {
            super(particles);
        }
        addToGroup(parent) {
            this.group = parent.addGroup("onClick", "Click Events");
            this.options = this.group.data;
            this.addProperties();
        }
        addProperties() {
            this.group.addProperty("enable", "Enable", object_gui_1.EditorType.boolean).change(async () => {
                await this.particles().refresh();
            });
            const modeSelectInput = this.group
                .addProperty("mode", "Mode", object_gui_1.EditorType.select)
                .change(async () => {
                await this.particles().refresh();
            })
                .addItems([
                {
                    value: "attract",
                },
                {
                    value: "bubble",
                },
                {
                    value: "pause",
                },
                {
                    value: "push",
                },
                {
                    value: "remove",
                },
                {
                    value: "repulse",
                },
                {
                    value: "trail",
                },
            ]);
            if (typeof tsparticles_plugin_absorbers_1.loadAbsorbersPlugin !== "undefined") {
                const absorbersGroup = "Absorbers";
                modeSelectInput.addItemGroup(absorbersGroup);
                modeSelectInput.addItem("absorber", undefined, absorbersGroup);
            }
            if (typeof tsparticles_plugin_emitters_1.loadEmittersPlugin !== "undefined") {
                const emittersGroup = "Emitters";
                modeSelectInput.addItemGroup(emittersGroup);
                modeSelectInput.addItem("emitter", undefined, emittersGroup);
            }
        }
    }
    exports.ClickEventsOptionsEditor = ClickEventsOptionsEditor;
});
