(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../../../EditorBase", "object-gui"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.MotionOptionsEditor = void 0;
    const EditorBase_1 = require("../../../EditorBase");
    const object_gui_1 = require("object-gui");
    class MotionOptionsEditor extends EditorBase_1.EditorBase {
        constructor(particles) {
            super(particles);
        }
        addToGroup(parent) {
            this.group = parent.addGroup("motion", "Motion");
            this.options = this.group.data;
            this.addReduce();
            this.addProperties();
        }
        addProperties() {
            this.group.addProperty("disable", "Disable", object_gui_1.EditorType.boolean).change(async () => {
                await this.particles().refresh();
            });
        }
        addReduce() {
            const coverGroup = this.group.addGroup("reduce", "Reduce");
            coverGroup
                .addProperty("factor", "Factor", object_gui_1.EditorType.number)
                .change(async () => {
                await this.particles().refresh();
            })
                .step(1);
            coverGroup.addProperty("value", "Value", object_gui_1.EditorType.boolean).change(async () => {
                await this.particles().refresh();
            });
        }
    }
    exports.MotionOptionsEditor = MotionOptionsEditor;
});
