(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../../../../EditorBase", "object-gui"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.ShapeOptionsEditor = void 0;
    const EditorBase_1 = require("../../../../EditorBase");
    const object_gui_1 = require("object-gui");
    class ShapeOptionsEditor extends EditorBase_1.EditorBase {
        constructor(particles) {
            super(particles);
        }
        addToGroup(parent) {
            this.group = parent.addGroup("shape", "Shape");
            this.options = this.group.data;
            this.addProperties();
        }
        addProperties() {
            const selectType = this.group.addProperty("type", "Type", object_gui_1.EditorType.select).change(async () => {
                await this.particles().refresh();
            });
            for (const key of this.particles().drawers.keys()) {
                selectType.addItem(key);
            }
        }
    }
    exports.ShapeOptionsEditor = ShapeOptionsEditor;
});
